> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://reference.flatfile.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://reference.flatfile.com/_mcp/server.

# Create an event

POST https://api.x.flatfile.com/v1/events
Content-Type: application/json

Reference: https://reference.flatfile.com/api-reference/events/create

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Body (application/json)

This endpoint expects a CreateEventConfig.

- `context` (Context, required) — The context of the event
- `domain` (enum, required) — The domain of the event
  - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
- `payload` (map from string to any, required)
- `topic` (enum, required) — The topic of the event
  - Allowed values: `agent:created`, `agent:updated`, `agent:deleted`, `space:created`, `space:updated`, `space:deleted`, `space:archived`, `space:unarchived`, `space:expired`, `space:guestAdded`, `space:guestRemoved`, `document:created`, `document:updated`, `document:deleted`, `workbook:created`, `workbook:updated`, `workbook:deleted`, `workbook:expired`, `workbook:thawed`, `flag:created`, `flag:updated`, `flag:deleted`, `sheet:created`, `sheet:updated`, `sheet:deleted`, `sheet:counts-updated`, `sheet:calculation-updated`, `snapshot:created`, `records:created`, `records:updated`, `records:deleted`, `file:created`, `file:updated`, `file:deleted`, `file:expired`, `job:created`, `job:updated`, `job:deleted`, `job:completed`, `job:ready`, `job:scheduled`, `job:outcome-acknowledged`, `job:parts-completed`, `job:failed`, `program:created`, `program:updated`, `program:recomputing`, `program:recomputed`, `commit:created`, `commit:updated`, `commit:completed`, `layer:created`, `secret:created`, `secret:updated`, `secret:deleted`, `cron:5-minutes`, `cron:hourly`, `cron:daily`, `cron:weekly`, `environment:created`, `environment:updated`, `environment:deleted`, `environment:autobuild-created`, `action:created`, `action:updated`, `action:deleted`, `data-clip:created`, `data-clip:updated`, `data-clip:deleted`, `data-clip:collaborator-updated`, `data-clip:resolutions-created`, `data-clip:resolutions-updated`, `data-clip:resolutions-refreshed`, `canvas:created`, `canvas:updated`, `canvas:deleted`, `canvas-area:created`, `canvas-area:updated`, `canvas-area:deleted`, `thread:created`, `thread:updated`, `thread:deleted`
- `attributes` (EventAttributes, optional) — The attributes of the event
- `callbackUrl` (string, optional) — The callback url to acknowledge the event
- `dataUrl` (string, optional) — The url to retrieve the data associated with the event
- `deletedAt` (datetime, optional) — Date the event was deleted
- `namespaces` (list of string, optional)
- `origin` (Origin, optional) — The origin resource of the event
- `target` (string, optional)

## Response

### 200

- `data` (Event, required) — An event that tracks an activity within an environment

## Errors

### 400 Bad Request Error

- `errors` (list of Error, required)

### 404 Not Found Error

- `errors` (list of Error, required)

## Types

### Context

The context of the event

- `accountId` (string, required) — Account ID
- `environmentId` (string, required) — Environment ID
- `namespaces` (list of string, optional) — The namespaces of the event
- `slugs` (EventContextSlugs, optional) — The slugs of related resources
- `actionName` (string, optional) — Name of an action
- `spaceId` (string, optional) — Space ID
- `workbookId` (string, optional) — Workbook ID
- `sheetId` (string, optional) — Sheet ID
- `sheetSlug` (string, optional) — Sheet Slug
- `snapshotId` (string, optional) — Snapshot ID
- `commitId` (string, optional) — Commit ID
- `jobId` (string, optional) — Pipeline Job ID
- `programId` (string, optional) — Mapping Program ID
- `fileId` (string, optional) — File ID
- `documentId` (string, optional) — Document ID
- `precedingEventId` (string, optional) — Event ID
- `actorId` (string, optional) — Can be a UserId, GuestId, or AgentId
- `appId` (string, optional) — App ID
- `actionId` (string, optional) — Action ID
- `dataClipId` (string, optional) — Data Clip ID
- `threadId` (string, optional) — Thread ID
- `filters` (map from string to string, optional)
- `entityId` (string, optional)
- `versionId` (string, optional, deprecated) — Deprecated, use `commitId` instead.

### EventAttributes

The attributes of the event

- `targetUpdatedAt` (datetime, optional) — Date the related entity was last updated
- `progress` (Progress, optional) — The progress of the event within a collection of iterable events

### Origin

The origin resource of the event

- `id` (string, optional)
- `slug` (string, optional)

### Event

An event that tracks an activity within an environment

- `topic`: `agent:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `agent:updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `agent:deleted`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `space:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `space:updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `space:deleted`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `space:archived`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `space:expired`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `space:guestAdded`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `space:guestRemoved`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `document:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `document:updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `document:deleted`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `workbook:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `workbook:updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `workbook:deleted`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `workbook:expired`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `workbook:thawed`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `flag:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `flag:updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `flag:deleted`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `sheet:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `sheet:updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `sheet:deleted`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `sheet:counts-updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `sheet:calculation-updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `snapshot:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `records:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `records:updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `records:deleted`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `file:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `file:updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `file:deleted`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `file:expired`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `job:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `job:updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `job:deleted`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `job:failed`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `job:completed`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `job:ready`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `job:scheduled`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `job:outcome-acknowledged`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `job:parts-completed`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `program:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `program:updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `commit:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `commit:updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `commit:completed`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `secret:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `secret:updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `secret:deleted`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `layer:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `environment:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `environment:updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `environment:deleted`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `environment:autobuild-created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `action:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `action:updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `action:deleted`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `data-clip:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `data-clip:updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `data-clip:deleted`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `data-clip:collaborator-updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `data-clip:resolutions-created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `data-clip:resolutions-updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `data-clip:resolutions-refreshed`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `canvas:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `canvas:updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `canvas:deleted`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `canvas-area:created`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `canvas-area:updated`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)
- `topic`: `canvas-area:deleted`
  - `context` (Context, required) — The context of the event
  - `createdAt` (datetime, required) — Date the event was created
  - `domain` (enum, required) — The domain of the event
    - Allowed values: `file`, `space`, `workbook`, `flag`, `job`, `document`, `sheet`, `program`, `secret`, `cron`, `environment`, `data-clip`, `canvas`, `canvas-area`, `thread`
  - `id` (string, required) — Event ID
  - `payload` (map from string to any, required)
  - `acknowledgedAt` (datetime, optional) — Date the event was acknowledged
  - `acknowledgedBy` (string, optional) — The actor (user or system) who acknowledged the event
  - `attributes` (EventAttributes, optional) — The attributes of the event
  - `callbackUrl` (string, optional) — The callback url to acknowledge the event
  - `dataUrl` (string, optional) — The url to retrieve the data associated with the event
  - `deletedAt` (datetime, optional) — Date the event was deleted
  - `namespaces` (list of string, optional)
  - `origin` (Origin, optional) — The origin resource of the event
  - `target` (string, optional)

### Error

- `message` (string, required)
- `key` (string, optional)

### EventContextSlugs

- `space` (string, optional) — The slug of the space
- `workbook` (string, optional) — The slug of the workbook
- `sheet` (string, optional) — The slug of the sheet

### Progress

The progress of the event within a collection of iterable events

- `current` (integer, optional) — The current progress of the event
- `total` (integer, optional) — The total number of events in this group
- `percent` (integer, optional) — The percent complete of the event group

## Examples

**Request**

```json
{
  "context": {
    "accountId": "us_acc_YOUR_ID",
    "environmentId": "us_env_YOUR_ID",
    "spaceId": "us_sp_YOUR_ID",
    "workbookId": "us_wb_YOUR_ID",
    "actorId": "us_key_SOME_KEY"
  },
  "domain": "workbook",
  "payload": {
    "recordsAdded": 100
  },
  "topic": "workbook:updated"
}
```

**Response**

```json
{
  "data": {
    "topic": "workbook:updated",
    "context": {
      "accountId": "us_acc_YOUR_ID",
      "environmentId": "us_env_YOUR_ID",
      "spaceId": "us_sp_YOUR_ID",
      "workbookId": "us_wb_YOUR_ID",
      "actorId": "us_key_SOME_KEY"
    },
    "createdAt": "2023-11-07T20:46:04.300Z",
    "domain": "workbook",
    "id": "us_evt_YOUR_ID",
    "payload": {
      "recordsAdded": 100
    },
    "callbackUrl": "",
    "dataUrl": "",
    "namespaces": [
      "workbook"
    ],
    "origin": {
      "id": "us_wb_YOUR_ID"
    }
  }
}
```

**SDK Code**

```python Example0
import requests

url = "https://api.x.flatfile.com/v1/events"

payload = {
    "context": {
        "accountId": "us_acc_YOUR_ID",
        "environmentId": "us_env_YOUR_ID",
        "spaceId": "us_sp_YOUR_ID",
        "workbookId": "us_wb_YOUR_ID",
        "actorId": "us_key_SOME_KEY"
    },
    "domain": "workbook",
    "payload": { "recordsAdded": 100 },
    "topic": "workbook:updated"
}
headers = {
    "X-Disable-Hooks": "true",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```typescript Example0
import { FlatfileClient } from "@flatfile/api";

const client = new FlatfileClient({ token: "YOUR_TOKEN" });
await client.events.create({
    topic: "workbook:updated",
    payload: {
        "recordsAdded": 100
    },
    domain: "workbook",
    context: {
        accountId: "us_acc_YOUR_ID",
        actorId: "us_key_SOME_KEY",
        environmentId: "us_env_YOUR_ID",
        spaceId: "us_sp_YOUR_ID",
        workbookId: "us_wb_YOUR_ID"
    }
});

```

```go Example0
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.x.flatfile.com/v1/events"

	payload := strings.NewReader("{\n  \"context\": {\n    \"accountId\": \"us_acc_YOUR_ID\",\n    \"environmentId\": \"us_env_YOUR_ID\",\n    \"spaceId\": \"us_sp_YOUR_ID\",\n    \"workbookId\": \"us_wb_YOUR_ID\",\n    \"actorId\": \"us_key_SOME_KEY\"\n  },\n  \"domain\": \"workbook\",\n  \"payload\": {\n    \"recordsAdded\": 100\n  },\n  \"topic\": \"workbook:updated\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-Disable-Hooks", "true")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example0
require 'uri'
require 'net/http'

url = URI("https://api.x.flatfile.com/v1/events")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Disable-Hooks"] = 'true'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"context\": {\n    \"accountId\": \"us_acc_YOUR_ID\",\n    \"environmentId\": \"us_env_YOUR_ID\",\n    \"spaceId\": \"us_sp_YOUR_ID\",\n    \"workbookId\": \"us_wb_YOUR_ID\",\n    \"actorId\": \"us_key_SOME_KEY\"\n  },\n  \"domain\": \"workbook\",\n  \"payload\": {\n    \"recordsAdded\": 100\n  },\n  \"topic\": \"workbook:updated\"\n}"

response = http.request(request)
puts response.read_body
```

```java Example0
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.x.flatfile.com/v1/events")
  .header("X-Disable-Hooks", "true")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"context\": {\n    \"accountId\": \"us_acc_YOUR_ID\",\n    \"environmentId\": \"us_env_YOUR_ID\",\n    \"spaceId\": \"us_sp_YOUR_ID\",\n    \"workbookId\": \"us_wb_YOUR_ID\",\n    \"actorId\": \"us_key_SOME_KEY\"\n  },\n  \"domain\": \"workbook\",\n  \"payload\": {\n    \"recordsAdded\": 100\n  },\n  \"topic\": \"workbook:updated\"\n}")
  .asString();
```

```php Example0
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.x.flatfile.com/v1/events', [
  'body' => '{
  "context": {
    "accountId": "us_acc_YOUR_ID",
    "environmentId": "us_env_YOUR_ID",
    "spaceId": "us_sp_YOUR_ID",
    "workbookId": "us_wb_YOUR_ID",
    "actorId": "us_key_SOME_KEY"
  },
  "domain": "workbook",
  "payload": {
    "recordsAdded": 100
  },
  "topic": "workbook:updated"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
    'X-Disable-Hooks' => 'true',
  ],
]);

echo $response->getBody();
```

```csharp Example0
using RestSharp;

var client = new RestClient("https://api.x.flatfile.com/v1/events");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Disable-Hooks", "true");
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"context\": {\n    \"accountId\": \"us_acc_YOUR_ID\",\n    \"environmentId\": \"us_env_YOUR_ID\",\n    \"spaceId\": \"us_sp_YOUR_ID\",\n    \"workbookId\": \"us_wb_YOUR_ID\",\n    \"actorId\": \"us_key_SOME_KEY\"\n  },\n  \"domain\": \"workbook\",\n  \"payload\": {\n    \"recordsAdded\": 100\n  },\n  \"topic\": \"workbook:updated\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Example0
import Foundation

let headers = [
  "X-Disable-Hooks": "true",
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "context": [
    "accountId": "us_acc_YOUR_ID",
    "environmentId": "us_env_YOUR_ID",
    "spaceId": "us_sp_YOUR_ID",
    "workbookId": "us_wb_YOUR_ID",
    "actorId": "us_key_SOME_KEY"
  ],
  "domain": "workbook",
  "payload": ["recordsAdded": 100],
  "topic": "workbook:updated"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.x.flatfile.com/v1/events")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```